package com.pon3gaming.pegasusfly;

import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockDamageEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityShootBowEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerQuitEvent;

public class PegasusFlyListener implements Listener {
	@EventHandler
	public void onMove(PlayerMoveEvent event) {
		Player player = event.getPlayer();
		if (event.getPlayer().hasPermission("pegfly.fly")
				&& !PegasusFly.isPegged.contains(event.getPlayer().getName())
				&& event.getPlayer().getFoodLevel() > 6) {
			event.getPlayer().setAllowFlight(true);
			PegasusFly.isPegged.add(event.getPlayer().getName());
			player.sendMessage(ChatColor.AQUA + "You can fly now!");
		} else if (PegasusFly.isPegged.contains(event.getPlayer().getName())
				&& player.getFoodLevel() < 7) {
			player.setAllowFlight(false);
			PegasusFly.isPegged.remove(player.getName());
			player.sendMessage(ChatColor.AQUA
					+ "You're too hungry to keep flying...");
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void onShoot(EntityShootBowEvent event) {
		if (event.getEntity() instanceof Player) {
			Player player = (Player) event.getEntity();
			if (PegasusFly.isPegged.contains(player.getName())
					&& !player.hasPermission("pegfly.nocost")
					&& player.isFlying()) {
				event.setCancelled(true);
			}
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void onPegBuild(BlockPlaceEvent event) {
		if (PegasusFly.isPegged.contains(event.getPlayer().getName())
				&& !event.getPlayer().hasPermission("pegfly.nocost")
				&& event.getBlock().getType() != Material.SNOW_BLOCK
				&& event.getPlayer().isFlying()) {
			event.setCancelled(true);
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void onInteract(BlockDamageEvent event) {
		if (PegasusFly.isPegged.contains(event.getPlayer().getName())
				&& !event.getPlayer().hasPermission("pegfly.nocost")
				&& event.getBlock().getType() != Material.SNOW_BLOCK
				&& event.getPlayer().isFlying()) {
			event.setCancelled(true);
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void onAttack(EntityDamageByEntityEvent event) {
		if (event.getDamager() instanceof Player) {
			Player player = (Player) event.getDamager();
			if (player.isFlying()
					&& PegasusFly.isPegged.contains(player.getName())
					&& !player.hasPermission("pegfly.nocost")) {
				event.setCancelled(true);
			}
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void onLogout(PlayerQuitEvent event) {
		if (event.getPlayer().hasPermission("pegfly.fly")
				&& PegasusFly.isPegged.contains(event.getPlayer().getName())) {
			PegasusFly.isPegged.remove(event.getPlayer().getName());
		}
	}
}